#include <R.h>
#include <Rmath.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
/*#include <gsl/gsl_sf_gamma.h>
  #include <gsl/gsl_sf_psi.h> */

#define PI M_PI
#define MINSIGMA 0.1   /* 0.000001*/
#define MINPI 0.000001
#define MINXI 0.000001

/* Constants for quantile computations */
#define FACTOR 1.6
#define NTRY 50
#define IBIS 500

double lambertw(double z);

void lambertwR(double *z, double *w0);

double erfc(double x);

double erf(double x);

double sign(double x);

void hpnll(double *theta, double *x, int *n, double *nll,double *nllgrad);

double normpdf(double mu, double sigma, double x);

double normcdf(double mu, double sigma, double x);

double normlogpdf(double mu, double sigma, double x);

double gpdpdf(double xi, double beta, double x);

double gpdlogpdf(double xi, double beta, double x);

double hpdf(double xi, double mu, double sigma, double x);

double hcdf(double xi, double mu, double sigma, double x);

double hlogpdf(double xi, double mu, double sigma, double x);

double softplus(double x);

double softplusinv(double x);

void ummhfwd(double *theta, int *m, double *params);

void ummhbwd(double *params, int *m, double *theta);

void ummhprint(double *params, int *m);

double ummhpdf(double *params, int m, double x);

void ummgpdfR(double *params, int *m, double *x, int *n, double *p);

void ummgcdfR(double *params, int *m, double *x, int *n, double *p);

void ummhpdfR(double *params, int *m, double *x, int *n, double *p);

double ummhcdf(double *params, int m, double x);

void ummhcdfR(double *params, int *m, double *x, int *n, double *p);

void hpdfgrad(double xi, double mu, double sigma, double x,
	      double *dhdtheta);

void ummhnll(double *theta, int *m, double *x, int *n, double *nll, 
	     double *nllgrad);


void ummhnll_bimodal_tailpen(double *theta, int *m, double * lambda, double *w,
			     double * beta, double *mu, double *sigma, double *x, int *n, 
			     double *nll,double *nllgrad);


int ummqbrack(double (*cdf)(double *,int, double),
	      double *params, int m, double q, double *a, double *b);

void ummquant(double (*cdf)(double *,int, double),
	       double (*pdf)(double *,int, double),
	       double *params, int m, double q, double *aa, double *bb,
	      double tol, int itmax, double *xq);

double ummgpdf(double *params, int m, double x);

double ummgcdf(double *params, int m, double x);

void ummgbwd(double *params, int *m, double *theta);
